﻿------------------------------------------------------------------------------
-- $Id$
------------------------------------------------------------------------------
--                                templates.lua
--
--	Copyright (C) 2012 Deronda, Maighurl, Doogal
--
--  This file is for use with clcInfo by abija.
--
--  abija has distributed clcInfo All Rights Reserved.  For more information
--  go to: http://wow.curseforge.com/addons/clctracker/
--
--  NOTE: When making changes to this file, please use WoW generated strings
--  to keep language localized.  Get spell names from GetSpellInfo(), item
--  names from GetItemInfo(), and use the global strings in
--  Interface\FrameXML\GlobalStrings.lua to accomplish this.
--
------------------------------------------------------------------------------
-- Author:
--      Deronda (@ Stormreaver), Maighurl, Doogal
------------------------------------------------------------------------------
-- Description:
--   Templates for clcInfo_Warlock
--------------------------------------------------------------------------------
-- loader
if not clcInfo then return end
if not clcInfo_Warlock then return end

clcInfo.optionsCMLoaders[#(clcInfo.optionsCMLoaders) + 1] = function()
    -- don't load if class is wrong
    local _, englishClass = UnitClass("player")
    if englishClass ~= clcInfo_Warlock.CLASS then return end
    
    local mod = clcInfo_Options.templates
    local defs = mod.defs
    local format = string.format
    
    local spells = clcInfo_Warlock.spells

    -- remove the default skill 1 that clcInfo creates
    local t = mod["icons"][defs.CLASS_3]
    if t then
        for k,v in pairs(t) do
            if string.find(v.name, "Destruction Rotation Skill 1") then 
                t[k] = nil
            end
        end
    end

    local name
    
    ------------------------------------------------------------------
    --Icons-----------------------------------------------------------
    ------------------------------------------------------------------

    -- Generic Warlock Icons------------------------------------------
    local basic_cds = clcInfo_Warlock.basic_cds
    -- get the localized names and make cd templates  
    for key, value in pairs(basic_cds) do
        name = GetSpellInfo(value)
        if not name then name = "Unknown Spell" end
        mod:Add("icons", defs.CLASS, name, format([[
        return IconSpell("%s")
        ]], name))
    end 

    --Dark Intent down
    name = spells["Dark Intent"].name
    mod:Add("icons", defs.CLASS, name,
    format([[
    if not UnitBuff("player", "%s") then return IconSpell("%s", true) end
    ]], name, name))

    --Fel Armor down
    name = spells["Fel Armor"].name
    mod:Add("icons", defs.CLASS, name,
    format([[
    if not UnitBuff("player", "%s") then return IconSpell("%s", true) end
    ]], name, name))
    
    --Pet is not out
    mod:Add("icons", defs.CLASS, SUMMON..":"..PET,
    format([[
    if not UnitExists("playerpet") and not IsMounted() and not UnitInVehicle("player") then
        local tabIndex = GetPrimaryTalentTree(false, false)
        local spell = "%s"
        if tabIndex == 1 then
            spell = "%s"
        elseif tabIndex == 2 then
            spell = "%s"
        end
        return IconSpell(spell, true)
    end
    ]], spells["Summon Imp"].name, spells["Summon Felhunter"].name, spells["Summon Felguard"].name))

    --No healthstone in inventory
    --It would be nice if this didn't display when the healthstone is on CD, but
    --there is no way to get the healthstone cd WITHOUT having one in inventory.
    local item_id = 5512
    mod:Add("icons", defs.CLASS, INVENTORY_TOOLTIP..":"..(GetItemInfo(item_id)),
    format([[
    local item_id = %d
    if not IsUsableItem(item_id) then
        return IconItem(item_id)
    end
    ]], item_id))

    --No soulstone in inventory
    item_id = 5232
    mod:Add("icons", defs.CLASS, INVENTORY_TOOLTIP..":"..(GetItemInfo(item_id)),
    format([[
    local item_id = %d
    if not IsUsableItem(item_id) then
        return IconItem(item_id)
    end
    ]], item_id))

    
    --Shadowflame range icon
    --This is a function linked to the emod because it uses the range library
    mod:Add("icons", defs.CLASS, spells["Shadowflame"].name, 'return IconShadowflame()')
    
    --Reduced casting speed debuff
    mod:Add("icons", defs.CLASS, AURA_TYPE_DEBUFF .. ":" .. SPELL_CASTING .. ":" .. SLOW,
    format([[
    return IconMAura("HARMFUL", "target", "%s", "%s", "%s", "%s", "%s", "%s")
    ]], spells["Curse of Tongues"].name, spells["Lava Breath"].name,
    spells["Mind-Numbing Poison"].name, spells["Necrotic Strike"].name,
    spells["Slow"] .name, spells["Spore Cloud"].name))
    
    -- Spell damage taken debuff
    mod:Add("icons", defs.CLASS, AURA_TYPE_DEBUFF .. ":" .. STAT_SPELLDAMAGE,
    format([[
    return IconMAura("HARMFUL", "target", "%s", "%s", "%s", "%s", "%s", "%s")
    ]], spells["Curse of the Elements"].name, spells["Earth and Moon"].name,
    spells["Ebon Plague"].name, spells["Fire Breath"].name,
    spells["Lightning Breath"].name, spells["Master Poisoner"].name))

    --Reduced physical damage done debuff
    mod:Add("icons", defs.CLASS, AURA_TYPE_DEBUFF .. ":" .. DAMAGE .. ":" .. 
                     STRING_SCHOOL_PHYSICAL .. ":" .. ACTION_SPELL_AURA_REMOVED_DOSE,
    format([[
    return IconMAura("HARMFUL", "target", "%s", "%s", "%s", "%s", "%s")
    ]], spells["Curse of Weakness"].name, spells["Demoralizing Roar"].name,
    spells["Demoralizing Screech"].name, spells["Demoralizing Shout"].name,
    spells["Scarlet Fever"].name, spells["Vindication"].name))


    -- Affliction Icons--------------------------------------------
--DOOG fill this in pls

    -- Demonology Icons--------------------------------------------
--Andy fill this in plox

    -- Destruction Icons-------------------------------------------
    name = spells["Chaos Bolt"].name
    mod:Add("icons", defs.CLASS_3, name, format([[
    return IconSpell("%s")
    ]], name))
        
    name = spells["Conflagrate"].name
    mod:Add("icons", defs.CLASS_3, name, format([[
    return IconSpell("%s")
    ]], name))

    name = spells["Empowered Imp"] .name
    mod:Add("icons", defs.CLASS_3, name, format([[
    return IconAura("%s")
    ]], name))

    name = spells["Shadowburn"].name
    mod:Add("icons", defs.CLASS_3, name, format([[
    if UnitExists("target") and UnitCanAttack("player", "target") and not UnitIsDead("target") then
        if floor(UnitHealth("target") / UnitHealthMax("target") * 100) < 20 then
            return IconSpell("%s", true)
        end
    end
    ]], name))
    
    name = spells["Shadowfury"].name
    mod:Add("icons", defs.CLASS_3, name, format([[
    return IconSpell("%s")
    ]], name))
    
    --Bars------------------------------------------------------------
    -- Generic Warlock Bars-------------------------------------------
    
    --Bane of Agony
    name = spells["Bane of Agony"].name
    mod:Add("bars", defs.CLASS, name, format([[
    return BarAura("HARMFUL|PLAYER", "target", "%s", nil, false, true)
    ]], name))
    
    --Bane of Doom
    name = spells["Bane of Doom"].name
    mod:Add("bars", defs.CLASS, name, format([[
    return BarAura("HARMFUL|PLAYER", "target", "%s", nil, false, true)
    ]], name))
    
    --Cast bar - probably better to use a castbar addon but, hey, we're a
    --one-stop shop.
    name = SPELL_CASTING
    mod:Add("bars", defs.CLASS, name, format([[
    local time = GetTime()
    local name, subText, text, texture, startTime, endTime = UnitCastingInfo("player")
    if name and time < endTime/1000 then
        return true, texture, 0, (endTime-startTime)/1000, time-(startTime/1000), nil, text, floor(time*10-startTime/100)/10, floor((endTime-startTime)/100)/10
    end
    ]]))
   
    --Corruption
    name = spells["Corruption"].name
    mod:Add("bars", defs.CLASS, name, format([[
    return BarAura("HARMFUL|PLAYER", "target", "%s", nil, false, true)
    ]], name))
    
    --Immolate
    name = spells["Immolate"].name
    mod:Add("bars", defs.CLASS, name, format([[
    return BarAura("HARMFUL|PLAYER", "target", "%s", nil, false, true)
    ]], name))
    
    --Mana
    name = MANA
    mod:Add("bars", defs.CLASS, name, format([[
    local mana = UnitPower("player")
    return true, "Interface/ICONS/INV_Elemental_Primal_Water", 0, UnitPowerMax("player"), mana, nil, "%s", nil, mana
    ]], name))  
    
    -- Affliction Bars-----------------------------------------
--Doog fill this in please

    -- Demonology Bars-----------------------------------------
--Andy!!  Demon bars if you would.

    -- Destruction Bars-----------------------------------------
    --Imrpoved Soul Fire
    name = spells["Improved Soul Fire"].name
    mod:Add("bars", defs.CLASS_3, name, format([[
    return BarAura("PLAYER", "player", "%s", nil, false, true)
    ]], name))   
    
    --Multi Icons------------------------------------------------------------
    --Shards
    -- The user can play with the look by going to the General tab,
    -- set "Use Skin From" to "Self", decrease spacing, and then go to
    -- the "Skin" tab and select "BareBone"... or not.
    name = COMBAT_TEXT_SHOW_COMBO_POINTS_TEXT
    mod:Add("micons", defs.CLASS, name, format([[
    local cp = GetComboPoints("player")
    for i = 1, cp do AddMIcon(nil, true, "Interface/ICONS/Spell_Frost_IceShard", 0, 0, 1, nil, nil, 1.0, false) end
    ]]))
    
  
    -- Priorities
    --------------------------------------------------------------------------------
    -- Affliction Priorities
--UNCOMMENT these when your module is written, Doog.
--    _, talent_tree_name = GetTalentTabInfo(1)
--    mod:Add("icons", defs.CLASS_1, format("%s %s: %s", talent_tree_name, COMBATLOG_HIGHLIGHT_ABILITY, REFORGE_CURRENT), 'return IconAfflictionCurrent()')
--    mod:Add("icons", defs.CLASS_1, format("%s %s: %s", talent_tree_name, COMBATLOG_HIGHLIGHT_ABILITY, NEXT), 'IconAfflictionNext()')
    
    -- Demonology Priorities
    _, talent_tree_name = GetTalentTabInfo(2)
    mod:Add("icons", defs.CLASS_2, format("%s %s: %s", talent_tree_name, COMBATLOG_HIGHLIGHT_ABILITY, REFORGE_CURRENT), 'return IconDemonologyCurrent()')
    mod:Add("icons", defs.CLASS_2, format("%s %s: %s", talent_tree_name, COMBATLOG_HIGHLIGHT_ABILITY, NEXT), 'IconDemonologyNext()')
    
    -- Destruction Priorities
    _, talent_tree_name = GetTalentTabInfo(3)
    mod:Add("icons", defs.CLASS_3, format("%s %s: %s", talent_tree_name, COMBATLOG_HIGHLIGHT_ABILITY, REFORGE_CURRENT), 'return IconDestructionCurrent()')
    mod:Add("icons", defs.CLASS_3, format("%s %s: %s", talent_tree_name, COMBATLOG_HIGHLIGHT_ABILITY, NEXT), 'IconDestructionNext()')
end